<?php
/********************************** ages *********************************
*	Cette fonction permet de calculer un âge et de l'afficher dans un
*	article, une rubrique, une brève, etc.
*
*	La syntaxe est la suivante :
*		<ages|n=date>
*
*	Exemples :
*		<ages|n=2000-01-01>
*		<ages|n=01-01-2000>
*
*	Formats de date supportés :
*		AAAA-MM-JJ
*		AAAA/MM/JJ
*		JJ-MM-AAAA
*		JJ/MM/AAAA
*
*	Auteur	: Gaël de Weerdt
*	Version	: 0.0.2
*	Date	: 01 Septembre 2015
*
*************************************************************************/

	function ages($uneDate) {
		$test1 = preg_match("/(^[0-9]{2})[-\/]([0-9]{2})[-\/]([0-9]{4}$)/", $uneDate);
		$test2 = preg_match("/(^[0-9]{4})[-\/]([0-9]{2})[-\/]([0-9]{2}$)/", $uneDate);
		
		// Si la date donné est bien dans un des formats acceptés
		if ($test1 or $test2) {
			// Formatage de la date ("AAA-MM-JJ")
			$uneDate = date('Y', strtotime($uneDate)) . '-' . date('m', strtotime($uneDate)) . '-' . date('j', strtotime($uneDate));
			
			$dateNaissance = new DateTime($uneDate);	// Création d'un objet 'DateTime" avec la date de naissance
			$dateActuelle  = new DateTime(date('Y-m-d'));	// Création d'un objet 'DateTime" avec la date actuelle
			
			$age = $dateNaissance->diff($dateActuelle);	// Calcule de la différence entre les deux dates
			
			// Récupère les chiffres
			$nb_jours  = $age->d;
			$nb_mois   = $age->m;
			$nb_annees = $age->y;
			
			// Gestion du singlulier et du pluriel
			($nb_jours > 1)  ? $d = "jours"  : $d = "jour";
			($nb_annees > 1) ? $y = "ans"    : $y = "an";
			
			// Gestion des différent cas d'affichage
			if ($nb_annees == 0 and $nb_mois == 0) {
				return("$nb_jours $d");
			}
			elseif ($nb_annees == 0 and $nb_jours == 0) {
				return("$nb_mois mois");
			}
			elseif ($nb_mois == 0 and $nb_jours == 0) {
				return("$nb_annees $y");
			}
			elseif ($nb_annees == 0) {
				return("$nb_mois mois et $nb_jours $d");
			}
			elseif ($nb_mois == 0) {
				return("$nb_annees $y et $nb_jours $d");
			}
			elseif ($nb_jours == 0) {
				return("$nb_annees $y et $nb_mois mois");
			}
			
			return("$nb_annees $y, $nb_mois mois et $nb_jours $d");
			
		} else {
			return("<b>Format de date invalide : ".$uneDate."</b>");
		}
	}
?>
